unit DynamicFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CHM;

type
  TDynamicForm = class(TForm)
    pnlControls: TPanel;
    memDisplay: TMemo;
    btnGo: TButton;
    Engine: TCHMdynamicEngine;
    procedure btnGoClick(Sender: TObject);
    procedure EngineLog(Sender: TObject; Line: String);
  private
    procedure OutputTable(Indent : string; Table: TCHMcustomTable);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DynamicForm: TDynamicForm;

implementation

{$R *.DFM}

procedure TDynamicForm.btnGoClick(Sender: TObject);
var
   Msg : string;
   MessageTable : TCHMdynamicMessage;
   MessageIndex : Integer;
begin
   Engine.WriteToLog('Load the definition file');
   Engine.WriteToLog('');
   Engine.Load('project.vmd');
   Engine.WriteToLog('This is our message...');
   Engine.WriteToLog('');
   Msg := 'MSH|^~\&|REGADT|MCM|RSP1P8|MCM|199601051530|SEC|ADT^A04|00000007|P|2.3' + #13;
   Msg := Msg + 'EVN|A44|199601051530' + #13;
   Msg := Msg + 'PID|||MR2^^^XYZ||JONES^WILLIAM^A^JR||19501010|M|||123 EAST STREET^^NY^NY^10021||(212)111-3333|||S||ACCT1' + #13;
   Msg := Msg + 'MRG|MR1^^^XYZ||ACCT1' + #13;
   Msg := Msg + 'MRG|MR1^^^XYZ||ACCT1' + #13;
   Msg := Msg + 'MRG|MR1^^^XYZ||ACCT1' + #13;
   Engine.WriteToLog(CHMconvertLineFeeds(Msg));
   MessageTable := nil;
   try
      MessageTable := TCHMdynamicMessage.Create(Engine);
      MessageIndex := Engine.ParseMessageDynamically(Msg, MessageTable);
      Engine.WriteToLog('Message name: ' + Engine.MessageName(MessageIndex));
      OutputTable('', MessageTable);
   finally
      MessageTable.Free;
   end;
   Engine.WriteToLog('');

end;

procedure TDynamicForm.OutputTable(Indent : string; Table : TCHMcustomTable);
var
   ColumnIndex : Integer;
   RowIndex, TableIndex : Integer;
   Line : string;
begin
   Engine.WriteToLog(Indent + 'Table: ' +  Table.TableName + '(' + IntToStr(Table.CountOfRow) + ' rows)');
   Line := Indent;
   if (Table.CountOfSubTable = 0) then
   begin
     for ColumnIndex := 0 to Table.CountOfColumn-1 do
     begin
        Line := Line + Table.ColumnName(ColumnIndex) + ' ';
     end;
     Engine.WriteToLog(Line);
     Line := Indent;
     for RowIndex := 0 to Table.CountOfRow - 1 do
     begin
        for ColumnIndex := 0 to Table.CountOfColumn-1 do
        begin
           case Table.ColumnType(ColumnIndex) of
              __CHM_STRING_TYPE:
              begin
                 Line := Line + '''' + Table.GetStringValue(RowIndex, ColumnIndex) + ''' ';
              end;
              __CHM_INTEGER_TYPE:
              begin
                 Line := Line + IntToStr(Table.GetIntegerValue(RowIndex, ColumnIndex)) + ' ';
              end;
              __CHM_DOUBLE_TYPE:
              begin
                 Line := Line + FloatToStr(Table.GetDoubleValue(RowIndex, ColumnIndex)) + ' ';
              end;
              __CHM_DATE_TIME_TYPE:
              begin
                 Line := Line + DateTimeToStr(Table.GetDateTimeValue(RowIndex, ColumnIndex).DateTime) + ' ';
              end;
           else

           end;
        end;
     end;
     Engine.WriteToLog(Line);
   end
   else
   begin
      for RowIndex := 0 to Table.CountOfRow -1 do
      begin
         for TableIndex := 0 to Table.CountOfSubTable-1 do
         begin
            OutputTable(Indent + '   ', Table.SubTable[RowIndex, TableIndex]);
         end;
      end;
   end;
end;

procedure TDynamicForm.EngineLog(Sender: TObject; Line: String);
begin
   memDisplay.Lines.Add(Line);
end;

end.
